;------------------------------------------------------
; A simple Messagebox application
; with Unicode/ASCII build
;
; NOTE: 
;	use -d _UNICODE in command line 
; 	to build this app for Unicode
;------------------------------------------------------


STD_INPUT_HANDLE	EQU	-10
STD_OUTPUT_HANDLE	EQU	-11

MB_OK			equ	0
MB_OKCANCEL		equ	1
MB_ABORTRETRYIGNORE	equ	2
MB_YESNO		equ	4
MB_RETRYCANCEL		equ	5


from kernel32.dll
	import	ExitProcess
	import	GetStdHandle


#ifdef _UNICODE
	from user32.dll
		import	MessageBox alias MessageBoxW

#else
	from user32.dll
		import	MessageBox alias MessageBoxA	
#endif


section "code" 		class_code
section "data"  	class_data
section "idata" 	class_imports


; A macro used to define a unicode string or an ascii string
; depending on "_UNICODE" symbol beeing defined
; similar to _T() in C/C++

macro TSTR
	marg 	my_str
	
	.data
	
	#ifdef _UNICODE
		@offset du my_str,0
	#else
		@offset db my_str,0
	#endif
	
	.code
	
	exitm @offset
endm


.data
	; those messages are not needed anymore
	; since we define strings with TSTR macro (see below)
	; for a full unicode application you can use "du" instead of "db"
	; and avoid TSTR
	sz_message	db	"First Win32 PE application",0
	sz_title	db	"Sol_ASM",0

.code

.entry start

start:

	invoke	MessageBox,0,<TSTR "First Unicode/ASCII Message box">, <TSTR "Sol_Asm">,MB_OKCANCEL

	invoke	ExitProcess,0
	ret





